// coded by bITmASTER
// bITmASTER@bigfoot.com


#include "libpsx.h"
#include "cdrom.h"


// Achtung ! Nutzung des gp (GlobalPointer) in Makefile mit -G0 ausschalten !!

void vbl_int( void );
void hex_dump( char *ptr );

char sector[204800];

volatile int *dma_ctrl = (int *) 0x1f8010f0;
volatile char *cd_rom = (char *) 0x1f801800;	
volatile int vbl_count;



// int cd_int_tab[] = { 0, 0xbfc0506c, 0xbfc04dec, 0 };

int main( void )
{	
	int i;
	int vbl_event;
	int cd_event;
	int start_block, size;
	char *buf;
	char pos[4];
	
	exit_critic();
	int_off( 0xffff );
//	_96_init();
//	CDInstallInt();
//	AddQueue( 0, cd_int_tab );

	vbl_event = OpenEvent( 0xf2000003, 0x2, 0x1000, vbl_int );
	EnableEvent( vbl_event );
	cd_event = OpenEvent( 0xf0000003, 0x1000, 0x1000, cd_int );
	EnableEvent( cd_event );
	int_on( 0x05 );
	
	buf = init_iso9660();	
//	hex_dump( buf );
	CDOpen( "SUBBAND.HEX;1", &start_block, &size );
	xprintf( "start_block: %d  size: %d\n", start_block, size );

	mmssdd( start_block, pos );
	cd_completed = 0;
	vbl_count = 0;
	SeekCD_( pos );
	while( ! cd_completed );
		

	cd_completed = 0;

	LoadCD_( 100, sector, 0x80 );	
	while( ! cd_completed );		
	i = vbl_count;
	
	xprintf( "Loading Time: %d VBLs\n", i );
	hex_dump( sector + 2048 );

	xprintf( "the end\n" );
	return( 1 );
}



void vbl_int( void )
{
	vbl_count++;
}


void hex_dump( char *ptr )
{
	int i, j;
	char d[] = { 0, 0 };
		
	for ( i = 0; i < 32; i++ ) {
		for ( j = 0; j < 16; j++ ) {
			xprintf( "%02.2x ", ptr[j+i*16] & 0xff );
		}
		xprintf( "  " );
		for ( j = 0; j < 16; j++ ) {
			d[0] = ptr[j+i*16];
			if ( ( d[0] >= 0x20 ) && ( d[0] < 0x7f ) )
				xprintf( "%s",  d );
			else
				xprintf( "." );
		}		
		xprintf( "\n" );
	}		
}
